Draft BezCurve

From FreeCAD Documentation
Jump to: navigation, search

Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎italiano • ‎polski • ‎română • ‎русский • ‎svenska • ‎Türkçe
Arrow-left.svg Previous: Draft Facebinder.svg Facebinder

Draft BezCurve.svg Draft BezCurve

Menu location
Draft → Bezier tools → BezCurve
Workbenches
Draft, Arch
Default shortcut
B Z
Introduced in version
0.14
See also
Draft Wire, Draft BSpline


Description

The BezCurve tool creates a Bezier Curve, or a piecewise Bezier curve, from several points. It uses the Draft Linestyle set on the Draft Tray.

The BezCurve tool curve uses control points to define the direction of the curve; on the other hand the Draft BSpline tool specifies the exact points through which the curve will go. To create exact circular or elliptical curves, use Draft Arc and Draft Ellipse.

Draft BezCurve Example.png

Bezier curve defined by multiple control points


How to use

  1. Press the Draft BezCurve.png Draft BezCurve button, or press B then Z keys.
  2. Click a first point on the 3D view, or type a coordinate and press the Draft AddPoint.svg add point button.
  3. Click additional points on the 3D view, or type a coordinate and press the Draft AddPoint.svg add point button.
  4. Press Esc or the Close button, or double-click the last point to complete the edition.

The object is created as a single Bezier curve of degree number_of_points - 1. It can be transformed to a piecewise wire made of curves of a specified degree by changing its properties.

The curve can be edited by double clicking on the element in the tree view, or by pressing the Draft Edit.svg Draft Edit button. Then you can move the points to a new position, or click Draft AddPoint.svg add point or Draft DelPoint.svg remove point and then click on the curve to add or remove points. You can also change the constraint type of each point.

Node constraints

The segment endpoints can be constrained such that adjacent control points are tangent or symmetric to the segments at the endpoint. First, start editing the curve, then pick one of the tools and then pick a point. Click again on the tool to deactivate it, so you can move the point.

  • Draft BezSharpNode.svg sharp remove constraints on the points so the curve can have sharp corners.
  • Draft BezTanNode.svg tangent force adjacent control points to be tangent.
  • Draft BezSymNode.svg symmetric force adjacent control points to be tangent and equidistant.

Limitations

  • The Points property does not yet appear in the properties list.
  • OpenCascade, and thus FreeCAD, does not support Bezier curves of degrees larger than 25. This should not be a problem in practice, as most users would typically use Bezier curves of degrees 3 to 5.

Options

  • Press A or the Draft FinishLine.png Finish button to finish the curve, leaving it open.
  • Press O or the Draft CloseLine.png Close button to close the curve, that is, a segment will be added from the last point to the first one to form a face. At least four points, a curve of degree three, are required to form a face.
  • Press W or the Draft Wipe.svg Wipe button to remove the curve segments already placed, but keep editing the curve from the last point.
  • Press U or the Draft SelectPlane.svg Set WP button to adjust the current working plane in the orientation of the last point.
  • Press X, Y or Z after a point to constrain the next point on the given axis.
  • To enter coordinates manually, simply enter the numbers, then press Enter between each X, Y and Z component.
  • Press R or click the checkbox to toggle relative mode. If relative mode is on, the coordinates of the next point are relative to the last one; if not, they are absolute, taken from the origin (0,0,0).
  • Press T or click the checkbox to toggle continue mode. If continue mode is on, the BezCurve tool will restart after you finish the curve, allowing you to draw another one without pressing the tool button again.
  • Press L or click the checkbox to toggle filled mode. If filled mode is on, a closed wire will create a filled face (DATAMake Face True); if not, the closed wire will not make a face (DATAMake Face False).
Note: the curve should not be filled if it intersects itself, as it won't create a proper face. If the curve is filled but no shape is visible, manually set DATAMake Face to False to see the curve.
  • Hold Ctrl while drawing to force snapping your point to the nearest snap location, independently of the distance.
  • Hold Shift while drawing to constrain your next point horizontally or vertically in relation to the last one.
  • Press Ctrl+Z or press the Draft UndoLine.png Undo button to undo the last point.
  • Press Esc or the Close button to abort the current command; curve segments already placed will remain.

Properties

Data

  • DATADegree: specifies the degree of the Bezier curve or the individual segments.
  • DATAClosed: specifies if the curve is closed or not. If the curve is initially open, this value is False; setting it to True will draw a segment to close the curve. If the curve is initially closed, this value is True; setting it to False will remove the last segment, and make the curve open.
  • DATAMake Face: specifies if the curve makes a face or not. If it is True a face is created, otherwise only the perimeter is considered part of the object. This property only works if DATAClosed is True.
Note: do not set DATAMake Face to True if the curve intersects itself, as it won't create a proper face.
  • DATAContinuity: (read-only) when the curve is closed, indicates the continuity of the curve [0], or [0,0]. Otherwise it's [].

View

  • VIEWArrow Size: specifies the size of the symbol displayed at the end of the curve.
  • VIEWArrow Type: specifies the type of symbol displayed at the end of the curve, which can be dot, circle, arrow, and tick.
  • VIEWEnd Arrow: specifies whether to show a symbol at the last point of the curve, so it can be used as an annotation line.
  • VIEWPattern: specifies a Draft Pattern with which to fill the face of the closed curve. This property only works if DATAMake Face is True, and if VIEWDisplay Mode is "Flat Lines".
  • VIEWPattern Size: specifies the size of the Draft Pattern.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

The BezCurve tool can be used in macros and from the Python console by using the following function:

BezCurve = makeBezCurve(pointslist, closed=False, placement=None, face=None, support=None, degree=None)
BezCurve = makeBezCurve(Part.Wire, closed=False, placement=None, face=None, support=None, degree=None)
  • Creates a BezCurve object with the given list of points, pointslist.
    • Each point in the list is defined by its FreeCAD.Vector, with units in millimeters.
    • Alternatively, the input can be a Part.Wire, from which points are extracted.
  • If closed is True, or if the first and last points are identical, the curve is closed.
  • If a placement is given, it is used; otherwise the shape is created at the origin.
  • If face is True, and the wire is closed, the wire will make a face, that is, it will appear filled.

Example:

import FreeCAD, Draft

p1 = FreeCAD.Vector(0, 0, 0)
p2 = FreeCAD.Vector(1000, 1000, 0)
p3 = FreeCAD.Vector(2000, 0, 0)
p4 = FreeCAD.Vector(1500, -2000, 0)

BezCurve1 = Draft.makeBezCurve([p1, p2, p3, p4], closed=True)
BezCurve2 = Draft.makeBezCurve([p4, 1.3*p2, p1, 4.1*p3], closed=True)
BezCurve3 = Draft.makeBezCurve([1.7*p3, 1.5*p4, 2.1*p2, p1], closed=True)
Arrow-left.svg Previous: Draft Facebinder.svg Facebinder